const system = require("../../../system");
var settings = require("../../../../config/settings");
var APIBase = require("../../api.base");

class TradetransferAPI extends APIBase {
  constructor() {
    super();
    this.execlient = system.getObject("util.execClient");
    this.channelApiUrl = settings.channelApiUrl();
    this.utilsNeedSve = system.getObject("service.utilsSve.utilsNeedSve");
  }

  /**
      * 接口跳转-POST请求
      * actionProcess  执行的流程
      * actionType     执行的类型
      * actionBody     执行的参数
      */
  async springBoard(pobj, qobj, req) {
    console.log(pobj);
    console.log(req);
    if (!pobj.action_type) {
      return system.getResult(null, "actionType参数不能为空");
    }
    console.log(pobj);
    var result = await this.opActionProcess(pobj, pobj.action_type);
    return result;
  }

  async opActionProcess(pobj, action_type) {
    var opResult = null;
    switch (action_type) {
      case "submitNeed"://提交需求
        opResult = await this.utilsNeedSve.reqcenterchannel(pobj);
        break;
      case "needClose"://关闭需求
        opResult = await this.utilsNeedSve.reqcenterchannel(pobj);
        break;
      case "receiveFeedback"://接收方案反馈信息
        opResult = await this.utilsNeedSve.reqcenterchannel(pobj);
        break;
      case "icpFeedbackSubmit"://接收方案反馈信息
        opResult = await this.utilsNeedSve.reqcenterchannel(pobj);
        break;
      case "paySuccess"://支付回调
        opResult = await this.utilsNeedSve.paySuccess(pobj);
        break;
      case "queryOrderState":// 通知状态变更
        opResult = await this.utilsNeedSve.queryOrderState(pobj);
        break;
      default:
        opResult = system.getResult(null, "action_type参数错误");
        break;
    }
    return opResult;
  }




}
module.exports = TradetransferAPI;
